source("code_flattopkernel.r")

Delaigle_Gijbels <- function(x_list,n,Y1,Y2){
#########################################################################
# Li-Vuong C.H. Estimation (USE x_list, n, Y1, and Y2 - RETURNS f_list)
#########################################################################
T_LIST = -1000:1000/100
MID_IDX = (length(T_LIST)+1)/2
MAT_Y1 = matrix(Y1,n,length(T_LIST))
MAT_EITY1 = exp( 1i * t(matrix(T_LIST,length(T_LIST),n)) * matrix(Y1,n,length(T_LIST)) )
MAT_EITY2 = exp( 1i * t(matrix(T_LIST,length(T_LIST),n)) * matrix(Y2,n,length(T_LIST)) )
E_Y1EITY2 = colMeans( MAT_Y1 * MAT_EITY2 )
E_EITY1 = colMeans( MAT_EITY1 )
E_EITY2 = colMeans( MAT_EITY2 )
PHI_X = array(0,length(T_LIST))
for( idx in 1:(length(T_LIST)-MID_IDX) ){
 PHI_X[MID_IDX+idx] = PHI_X[MID_IDX+idx-1] + 1i*E_Y1EITY2[MID_IDX+idx]/E_EITY2[MID_IDX+idx] * (T_LIST[MID_IDX+idx]-T_LIST[MID_IDX+idx-1])
 PHI_X[MID_IDX-idx] = PHI_X[MID_IDX-idx+1] + 1i*E_Y1EITY2[MID_IDX-idx]/E_EITY2[MID_IDX-idx] * (T_LIST[MID_IDX-idx]-T_LIST[MID_IDX-idx+1])
}
PHI_X = exp(PHI_X)
PHI_U1 = E_EITY1 / exp(PHI_X)

#########################################################################
# Delaigle-Gijbels Bandwidth Choice by Normal Reference (NR)
#########################################################################
h_list = 1:1000/1000
AMISE_list = NULL
for( h in h_list ){
 AMISE = sum( Mod( get_phi_k(T_LIST*h)/PHI_U1 )^2 ) * h * (T_LIST[2]-T_LIST[1]) / (2 * 3.14159 * n * h)
 AMISE = AMISE + MU2 * 0.375 / 3.14159^0.5 * cov(Y1,Y2)^(-5/2) * h^4 / 4
 AMISE_list = c( AMISE_list, AMISE )
}
h = h_list[order(AMISE_list)[1]]

return( h )
}