source("code_loss.r")

fobjective <- function(theta,x_idx,MAXI,PPara,mat_E_R,mat_E_I,mat_E_R_MB,mat_E_I_MB,n,alpha,eta,delta,L,psi_list,phi_list){
 #########################################################################
 # Compute the Test Statistic T_theta
 #########################################################################
 E_R_theta = mat_E_R %*% theta
 E_I_theta = mat_E_I %*% theta
 E_R_theta_MB = kronecker( diag(array(1,L)), t(theta) ) %*% mat_E_R_MB
 E_I_theta_MB = kronecker( diag(array(1,L)), t(theta) ) %*% mat_E_I_MB
 theta_V_R_theta = NULL
 theta_V_I_theta = NULL
 for( l in 1:L ){
  theta_V_R_theta_l = t(theta) %*% mat_V_R[( (q+1)*(l-1)+1 ):( (q+1)*l ),] %*% theta
  theta_V_I_theta_l = t(theta) %*% mat_V_I[( (q+1)*(l-1)+1 ):( (q+1)*l ),] %*% theta
  theta_V_R_theta = rbind( theta_V_R_theta, theta_V_R_theta_l)
  theta_V_I_theta = rbind( theta_V_I_theta, theta_V_I_theta_l)
 }

 T_theta = n^0.5 * rbind( (E_R_theta - delta), (-1*E_R_theta - delta), (E_I_theta - delta), (-1*E_I_theta - delta) ) / rbind( theta_V_R_theta^0.5, theta_V_R_theta^0.5, theta_V_I_theta^0.5, theta_V_I_theta^0.5 )

 #########################################################################
 # Compute the Critical Value c_alpha
 #########################################################################
 #c_alpha = qnorm( 1 - alpha/(4*L) ) / ( 1 - qnorm( 1 - alpha/(4L) )^2/n )
 c_alpha_R = n^(-0.5) * apply(abs(E_R_theta_MB), MARGIN = 1, FUN = quantile, probs = 0.95) / theta_V_R_theta^0.5
 c_alpha_R[is.na(c_alpha_R)]=999999
 c_alpha_R[is.infinite(c_alpha_R)]=999999
 c_alpha_I = n^(-0.5) * apply(abs(E_I_theta_MB), MARGIN = 1, FUN = quantile, probs = 0.95) / theta_V_I_theta^0.5
 c_alpha_I[is.na(c_alpha_I)]=999999
 c_alpha_I[is.infinite(c_alpha_I)]=999999
 c_alpha = rbind( c_alpha_R, c_alpha_R, c_alpha_I, c_alpha_I )

 #########################################################################
 # Compute the Density Estimate as length(x_list) by 1 Matrix psiT_theta
 #########################################################################
 psiT_theta = psi_list %*% theta

 #########################################################################
 # Compute the C.F at 0 as phiT_theta
 #########################################################################
 mat_I = diag( Re( (1i)^(0:q) ) )
 phiT_theta = (2*3.14159)^0.5 * phi_list %*% mat_I %*% theta

 #########################################################################
 # Compute the Objective and Constraint Penalties
 #########################################################################
 #objective = psiT_theta[x_idx] * (-1)^(MAXI==TRUE) + 0.1 * mean(theta^2)
 objective = -1*((psiT_theta[x_idx])^2)^0.25
 if( !MAXI ){
  objective = (psiT_theta[x_idx]^2)^1
 }
 penalty = loss( max(T_theta - c_alpha) )/min(c_alpha) + loss( phiT_theta - 1 + (2*3.14159)^0.5 * eta )/2 + loss( -phiT_theta + 1 - (2*3.14159)^0.5 * eta )/2
 return( objective + PPara*penalty )
}